// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QANIMATIONCALLBACKWRAPPER_H
#define SBK_QANIMATIONCALLBACKWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DAnimation/qanimationcallback.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAnimationCallbackWrapper : public Qt3DAnimation::QAnimationCallback
{
public:
    QAnimationCallbackWrapper();
    QAnimationCallbackWrapper(const QAnimationCallbackWrapper &) = delete;
    QAnimationCallbackWrapper& operator=(const QAnimationCallbackWrapper &) = delete;
    QAnimationCallbackWrapper(QAnimationCallbackWrapper &&) = delete;
    QAnimationCallbackWrapper& operator=(QAnimationCallbackWrapper &&) = delete;
    ~QAnimationCallbackWrapper() override;

    void valueChanged(const ::QVariant & value) override;
    static void sbk_o_valueChanged(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QVariant & value);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QANIMATIONCALLBACKWRAPPER_H
