// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QLOGICASPECTWRAPPER_H
#define SBK_QLOGICASPECTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DLogic/qlogicaspect.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QLogicAspectWrapper : public Qt3DLogic::QLogicAspect
{
public:
    QLogicAspectWrapper(::QObject * parent = nullptr);
    QLogicAspectWrapper(const QLogicAspectWrapper &) = delete;
    QLogicAspectWrapper& operator=(const QLogicAspectWrapper &) = delete;
    QLogicAspectWrapper(QLogicAspectWrapper &&) = delete;
    QLogicAspectWrapper& operator=(QLogicAspectWrapper &&) = delete;
    ~QLogicAspectWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    ::QStringList dependencies() const override;
    static ::QStringList sbk_o_dependencies(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QLOGICASPECTWRAPPER_H
