// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_PROPERTYREADERINTERFACEWRAPPER_H
#define SBK_PROPERTYREADERINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qshaderdata.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class PropertyReaderInterfaceWrapper : public Qt3DRender::PropertyReaderInterface
{
public:
    PropertyReaderInterfaceWrapper();
    PropertyReaderInterfaceWrapper(const PropertyReaderInterfaceWrapper &) = delete;
    PropertyReaderInterfaceWrapper& operator=(const PropertyReaderInterfaceWrapper &) = delete;
    PropertyReaderInterfaceWrapper(PropertyReaderInterfaceWrapper &&) = delete;
    PropertyReaderInterfaceWrapper& operator=(PropertyReaderInterfaceWrapper &&) = delete;
    ~PropertyReaderInterfaceWrapper() override;

    ::QVariant readProperty(const ::QVariant & v) override;
    static ::QVariant sbk_o_readProperty(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QVariant & v);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_PROPERTYREADERINTERFACEWRAPPER_H
