// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QABSTRACTTEXTUREIMAGEWRAPPER_H
#define SBK_QABSTRACTTEXTUREIMAGEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qabstracttextureimage.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QAbstractTextureImageWrapper : public Qt3DRender::QAbstractTextureImage
{
public:
    QAbstractTextureImageWrapper(::Qt3DCore::QNode * parent = nullptr);
    QAbstractTextureImageWrapper(const QAbstractTextureImageWrapper &) = delete;
    QAbstractTextureImageWrapper& operator=(const QAbstractTextureImageWrapper &) = delete;
    QAbstractTextureImageWrapper(QAbstractTextureImageWrapper &&) = delete;
    QAbstractTextureImageWrapper& operator=(QAbstractTextureImageWrapper &&) = delete;
    ~QAbstractTextureImageWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> dataGenerator() const override;
    static ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> sbk_o_dataGenerator(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QABSTRACTTEXTUREIMAGEWRAPPER_H
