// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTEXTUREWRAPMODEWRAPPER_H
#define SBK_QTEXTUREWRAPMODEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qtexturewrapmode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QTextureWrapModeWrapper : public Qt3DRender::QTextureWrapMode
{
public:
    QTextureWrapModeWrapper(::Qt3DRender::QTextureWrapMode::WrapMode wrapMode = Qt3DRender::QTextureWrapMode::WrapMode::ClampToEdge, ::QObject * parent = nullptr);
    QTextureWrapModeWrapper(::Qt3DRender::QTextureWrapMode::WrapMode x, ::Qt3DRender::QTextureWrapMode::WrapMode y, ::Qt3DRender::QTextureWrapMode::WrapMode z, ::QObject * parent = nullptr);
    QTextureWrapModeWrapper(const QTextureWrapModeWrapper &) = delete;
    QTextureWrapModeWrapper& operator=(const QTextureWrapModeWrapper &) = delete;
    QTextureWrapModeWrapper(QTextureWrapModeWrapper &&) = delete;
    QTextureWrapModeWrapper& operator=(QTextureWrapModeWrapper &&) = delete;
    ~QTextureWrapModeWrapper() override;

    void childEvent(::QChildEvent * event) override;
    static void sbk_o_childEvent(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QChildEvent * event);
    void connectNotify(const ::QMetaMethod & signal) override;
    static void sbk_o_connectNotify(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QMetaMethod & signal);
    void customEvent(::QEvent * event) override;
    static void sbk_o_customEvent(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QEvent * event);
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    static bool sbk_o_event(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QEvent * event);
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    static bool sbk_o_eventFilter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * watched, ::QEvent * event);
    void timerEvent(::QTimerEvent * event) override;
    static void sbk_o_timerEvent(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QTimerEvent * event);

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QTEXTUREWRAPMODEWRAPPER_H
