// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QABSTRACTAXISWRAPPER_H
#define SBK_QABSTRACTAXISWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtCharts/qabstractaxis.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QAbstractAxisWrapper : public QAbstractAxis
{
public:
    QAbstractAxisWrapper(const QAbstractAxisWrapper &) = delete;
    QAbstractAxisWrapper& operator=(const QAbstractAxisWrapper &) = delete;
    QAbstractAxisWrapper(QAbstractAxisWrapper &&) = delete;
    QAbstractAxisWrapper& operator=(QAbstractAxisWrapper &&) = delete;
    ~QAbstractAxisWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QAbstractAxis::AxisType type() const override;
    static ::QAbstractAxis::AxisType sbk_o_type(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QABSTRACTAXISWRAPPER_H
