// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QBOXPLOTSERIESWRAPPER_H
#define SBK_QBOXPLOTSERIESWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtCharts/qboxplotseries.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QBoxPlotSeriesWrapper : public QBoxPlotSeries
{
public:
    QBoxPlotSeriesWrapper(::QObject * parent = nullptr);
    QBoxPlotSeriesWrapper(const QBoxPlotSeriesWrapper &) = delete;
    QBoxPlotSeriesWrapper& operator=(const QBoxPlotSeriesWrapper &) = delete;
    QBoxPlotSeriesWrapper(QBoxPlotSeriesWrapper &&) = delete;
    QBoxPlotSeriesWrapper& operator=(QBoxPlotSeriesWrapper &&) = delete;
    ~QBoxPlotSeriesWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QAbstractSeries::SeriesType type() const override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QBOXPLOTSERIESWRAPPER_H
