// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QXYSERIESWRAPPER_H
#define SBK_QXYSERIESWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <pyside_numpy.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QXYSeriesWrapper : public QXYSeries
{
public:
    QXYSeriesWrapper(const QXYSeriesWrapper &) = delete;
    QXYSeriesWrapper& operator=(const QXYSeriesWrapper &) = delete;
    QXYSeriesWrapper(QXYSeriesWrapper &&) = delete;
    QXYSeriesWrapper& operator=(QXYSeriesWrapper &&) = delete;
    ~QXYSeriesWrapper() override;

    void childEvent(::QChildEvent * event) override;
    ::QColor color() const override;
    static ::QColor sbk_o_color(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void setBrush(const ::QBrush & brush) override;
    static void sbk_o_setBrush(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QBrush & brush);
    void setColor(const ::QColor & color) override;
    static void sbk_o_setColor(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QColor & color);
    void setPen(const ::QPen & pen) override;
    static void sbk_o_setPen(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QPen & pen);
    void timerEvent(::QTimerEvent * event) override;
    ::QAbstractSeries::SeriesType type() const override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[12] = {false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QXYSERIESWRAPPER_H
