// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QABSTRACTNATIVEEVENTFILTERWRAPPER_H
#define SBK_QABSTRACTNATIVEEVENTFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qabstractnativeeventfilter.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAbstractNativeEventFilterWrapper : public QAbstractNativeEventFilter
{
public:
    QAbstractNativeEventFilterWrapper();
    QAbstractNativeEventFilterWrapper(const QAbstractNativeEventFilterWrapper &) = delete;
    QAbstractNativeEventFilterWrapper& operator=(const QAbstractNativeEventFilterWrapper &) = delete;
    QAbstractNativeEventFilterWrapper(QAbstractNativeEventFilterWrapper &&) = delete;
    QAbstractNativeEventFilterWrapper& operator=(QAbstractNativeEventFilterWrapper &&) = delete;
    ~QAbstractNativeEventFilterWrapper() override;

    bool nativeEventFilter(const ::QByteArray & eventType, void * message, ::qintptr * result) override;
    static bool sbk_o_nativeEventFilter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QByteArray & eventType, void * message, ::qintptr * result);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QABSTRACTNATIVEEVENTFILTERWRAPPER_H
