// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDYNAMICPROPERTYCHANGEEVENTWRAPPER_H
#define SBK_QDYNAMICPROPERTYCHANGEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qcoreevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QDynamicPropertyChangeEventWrapper : public QDynamicPropertyChangeEvent
{
public:
    QDynamicPropertyChangeEventWrapper(const ::QByteArray & name);
    QDynamicPropertyChangeEventWrapper(const QDynamicPropertyChangeEventWrapper &) = delete;
    QDynamicPropertyChangeEventWrapper(const QDynamicPropertyChangeEvent& self) : QDynamicPropertyChangeEvent(self)
    {
    }
    QDynamicPropertyChangeEventWrapper& operator=(const QDynamicPropertyChangeEventWrapper &) = delete;
    QDynamicPropertyChangeEventWrapper(QDynamicPropertyChangeEventWrapper &&) = delete;
    QDynamicPropertyChangeEventWrapper& operator=(QDynamicPropertyChangeEventWrapper &&) = delete;
    ~QDynamicPropertyChangeEventWrapper() override;

    ::QDynamicPropertyChangeEvent * clone() const override;
    static ::QDynamicPropertyChangeEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QDYNAMICPROPERTYCHANGEEVENTWRAPPER_H
