// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFUTUREINTERFACEBASEWRAPPER_H
#define SBK_QFUTUREINTERFACEBASEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qfutureinterface.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QFutureInterfaceBaseWrapper : public QFutureInterfaceBase
{
public:
    QFutureInterfaceBaseWrapper(::QFutureInterfaceBase::State initialState = QFutureInterfaceBase::State::NoState);
    QFutureInterfaceBaseWrapper(const QFutureInterfaceBaseWrapper &) = delete;
    QFutureInterfaceBaseWrapper(const QFutureInterfaceBase& self) : QFutureInterfaceBase(self)
    {
    }
    QFutureInterfaceBaseWrapper& operator=(const QFutureInterfaceBaseWrapper &) = delete;
    QFutureInterfaceBaseWrapper(QFutureInterfaceBaseWrapper &&) = delete;
    QFutureInterfaceBaseWrapper& operator=(QFutureInterfaceBaseWrapper &&) = delete;
    ~QFutureInterfaceBaseWrapper() override;

    static void pysideInitQtMetaTypes();

private:
};

#endif // SBK_QFUTUREINTERFACEBASEWRAPPER_H
