// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QITEMSELECTIONMODELWRAPPER_H
#define SBK_QITEMSELECTIONMODELWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qitemselectionmodel.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QItemSelectionModelWrapper : public QItemSelectionModel
{
public:
    QItemSelectionModelWrapper(::QAbstractItemModel * model = nullptr);
    QItemSelectionModelWrapper(::QAbstractItemModel * model, ::QObject * parent);
    QItemSelectionModelWrapper(const QItemSelectionModelWrapper &) = delete;
    QItemSelectionModelWrapper& operator=(const QItemSelectionModelWrapper &) = delete;
    QItemSelectionModelWrapper(QItemSelectionModelWrapper &&) = delete;
    QItemSelectionModelWrapper& operator=(QItemSelectionModelWrapper &&) = delete;
    ~QItemSelectionModelWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void clear() override;
    void clearCurrentIndex() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void reset() override;
    void select(const ::QItemSelection & selection, ::QFlags<QItemSelectionModel::SelectionFlag> command) override;
    static void sbk_o_select(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QItemSelection & selection, ::QFlags<QItemSelectionModel::SelectionFlag> command);
    void select(const ::QModelIndex & index, ::QFlags<QItemSelectionModel::SelectionFlag> command) override;
    static void sbk_o_select(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QModelIndex & index, ::QFlags<QItemSelectionModel::SelectionFlag> command);
    void setCurrentIndex(const ::QModelIndex & index, ::QFlags<QItemSelectionModel::SelectionFlag> command) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QITEMSELECTIONMODELWRAPPER_H
