// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPAUSEANIMATIONWRAPPER_H
#define SBK_QPAUSEANIMATIONWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qpauseanimation.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QPauseAnimationWrapper : public QPauseAnimation
{
public:
    QPauseAnimationWrapper(::QObject * parent = nullptr);
    QPauseAnimationWrapper(int msecs, ::QObject * parent = nullptr);
    QPauseAnimationWrapper(const QPauseAnimationWrapper &) = delete;
    QPauseAnimationWrapper& operator=(const QPauseAnimationWrapper &) = delete;
    QPauseAnimationWrapper(QPauseAnimationWrapper &&) = delete;
    QPauseAnimationWrapper& operator=(QPauseAnimationWrapper &&) = delete;
    ~QPauseAnimationWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    int duration() const override;
    bool event(::QEvent * e) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    void updateCurrentTime(int arg__1) override;
    void updateDirection(::QAbstractAnimation::Direction direction) override;
    void updateState(::QAbstractAnimation::State newState, ::QAbstractAnimation::State oldState) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[11] = {false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QPAUSEANIMATIONWRAPPER_H
