// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRUNNABLEWRAPPER_H
#define SBK_QRUNNABLEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qrunnable.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRunnableWrapper : public QRunnable
{
public:
    QRunnableWrapper() noexcept;
    QRunnableWrapper(const QRunnableWrapper &) = delete;
    QRunnableWrapper& operator=(const QRunnableWrapper &) = delete;
    QRunnableWrapper(QRunnableWrapper &&) = delete;
    QRunnableWrapper& operator=(QRunnableWrapper &&) = delete;
    ~QRunnableWrapper() override;

    void run() override;
    static void sbk_o_run(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QRUNNABLEWRAPPER_H
