// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTIMEREVENTWRAPPER_H
#define SBK_QTIMEREVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qcoreevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QTimerEventWrapper : public QTimerEvent
{
public:
    QTimerEventWrapper(::Qt::TimerId timerId);
    QTimerEventWrapper(int timerId);
    QTimerEventWrapper(const QTimerEventWrapper &) = delete;
    QTimerEventWrapper(const QTimerEvent& self) : QTimerEvent(self)
    {
    }
    QTimerEventWrapper& operator=(const QTimerEventWrapper &) = delete;
    QTimerEventWrapper(QTimerEventWrapper &&) = delete;
    QTimerEventWrapper& operator=(QTimerEventWrapper &&) = delete;
    ~QTimerEventWrapper() override;

    ::QTimerEvent * clone() const override;
    static ::QTimerEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QTIMEREVENTWRAPPER_H
