// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QXMLSTREAMENTITYRESOLVERWRAPPER_H
#define SBK_QXMLSTREAMENTITYRESOLVERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qxmlstream.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QXmlStreamEntityResolverWrapper : public QXmlStreamEntityResolver
{
public:
    QXmlStreamEntityResolverWrapper();
    QXmlStreamEntityResolverWrapper(const QXmlStreamEntityResolverWrapper &) = delete;
    QXmlStreamEntityResolverWrapper& operator=(const QXmlStreamEntityResolverWrapper &) = delete;
    QXmlStreamEntityResolverWrapper(QXmlStreamEntityResolverWrapper &&) = delete;
    QXmlStreamEntityResolverWrapper& operator=(QXmlStreamEntityResolverWrapper &&) = delete;
    ~QXmlStreamEntityResolverWrapper() override;

    ::QString resolveEntity(const ::QString & publicId, const ::QString & systemId) override;
    static ::QString sbk_o_resolveEntity(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & publicId, const ::QString & systemId);
    ::QString resolveUndeclaredEntity(const ::QString & name) override;
    static ::QString sbk_o_resolveUndeclaredEntity(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & name);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QXMLSTREAMENTITYRESOLVERWRAPPER_H
