// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QITEMMODELSCATTERDATAPROXYWRAPPER_H
#define SBK_QITEMMODELSCATTERDATAPROXYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDataVisualization/qitemmodelscatterdataproxy.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QItemModelScatterDataProxyWrapper : public QItemModelScatterDataProxy
{
public:
    QItemModelScatterDataProxyWrapper(::QAbstractItemModel * itemModel, ::QObject * parent = nullptr);
    QItemModelScatterDataProxyWrapper(::QAbstractItemModel * itemModel, const ::QString & xPosRole, const ::QString & yPosRole, const ::QString & zPosRole, ::QObject * parent = nullptr);
    QItemModelScatterDataProxyWrapper(::QAbstractItemModel * itemModel, const ::QString & xPosRole, const ::QString & yPosRole, const ::QString & zPosRole, const ::QString & rotationRole, ::QObject * parent = nullptr);
    QItemModelScatterDataProxyWrapper(::QObject * parent = nullptr);
    QItemModelScatterDataProxyWrapper(const QItemModelScatterDataProxyWrapper &) = delete;
    QItemModelScatterDataProxyWrapper& operator=(const QItemModelScatterDataProxyWrapper &) = delete;
    QItemModelScatterDataProxyWrapper(QItemModelScatterDataProxyWrapper &&) = delete;
    QItemModelScatterDataProxyWrapper& operator=(QItemModelScatterDataProxyWrapper &&) = delete;
    ~QItemModelScatterDataProxyWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QITEMMODELSCATTERDATAPROXYWRAPPER_H
