// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDESIGNERCUSTOMWIDGETCOLLECTIONINTERFACEWRAPPER_H
#define SBK_QDESIGNERCUSTOMWIDGETCOLLECTIONINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtUiPlugin/customwidget.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QDesignerCustomWidgetCollectionInterfaceWrapper : public QDesignerCustomWidgetCollectionInterface
{
public:
    QDesignerCustomWidgetCollectionInterfaceWrapper();
    QDesignerCustomWidgetCollectionInterfaceWrapper(const QDesignerCustomWidgetCollectionInterfaceWrapper &) = delete;
    QDesignerCustomWidgetCollectionInterfaceWrapper& operator=(const QDesignerCustomWidgetCollectionInterfaceWrapper &) = delete;
    QDesignerCustomWidgetCollectionInterfaceWrapper(QDesignerCustomWidgetCollectionInterfaceWrapper &&) = delete;
    QDesignerCustomWidgetCollectionInterfaceWrapper& operator=(QDesignerCustomWidgetCollectionInterfaceWrapper &&) = delete;
    ~QDesignerCustomWidgetCollectionInterfaceWrapper() override;

    ::QList<QDesignerCustomWidgetInterface*> customWidgets() const override;
    static ::QList<QDesignerCustomWidgetInterface*> sbk_o_customWidgets(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QDESIGNERCUSTOMWIDGETCOLLECTIONINTERFACEWRAPPER_H
