// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDESIGNERCUSTOMWIDGETINTERFACEWRAPPER_H
#define SBK_QDESIGNERCUSTOMWIDGETINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtUiPlugin/customwidget.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QDesignerCustomWidgetInterfaceWrapper : public QDesignerCustomWidgetInterface
{
public:
    QDesignerCustomWidgetInterfaceWrapper();
    QDesignerCustomWidgetInterfaceWrapper(const QDesignerCustomWidgetInterfaceWrapper &) = delete;
    QDesignerCustomWidgetInterfaceWrapper& operator=(const QDesignerCustomWidgetInterfaceWrapper &) = delete;
    QDesignerCustomWidgetInterfaceWrapper(QDesignerCustomWidgetInterfaceWrapper &&) = delete;
    QDesignerCustomWidgetInterfaceWrapper& operator=(QDesignerCustomWidgetInterfaceWrapper &&) = delete;
    ~QDesignerCustomWidgetInterfaceWrapper() override;

    ::QString codeTemplate() const override;
    static ::QString sbk_o_codeTemplate(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QWidget * createWidget(::QWidget * parent) override;
    static ::QWidget * sbk_o_createWidget(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QWidget * parent);
    ::QString domXml() const override;
    ::QString group() const override;
    ::QIcon icon() const override;
    static ::QIcon sbk_o_icon(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QString includeFile() const override;
    void initialize(::QDesignerFormEditorInterface * core) override;
    static void sbk_o_initialize(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QDesignerFormEditorInterface * core);
    bool isContainer() const override;
    bool isInitialized() const override;
    ::QString name() const override;
    ::QString toolTip() const override;
    ::QString whatsThis() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[12] = {false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDESIGNERCUSTOMWIDGETINTERFACEWRAPPER_H
