// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDESIGNERDYNAMICPROPERTYSHEETEXTENSIONWRAPPER_H
#define SBK_QDESIGNERDYNAMICPROPERTYSHEETEXTENSIONWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/dynamicpropertysheet.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QDesignerDynamicPropertySheetExtensionWrapper : public QDesignerDynamicPropertySheetExtension
{
public:
    QDesignerDynamicPropertySheetExtensionWrapper();
    QDesignerDynamicPropertySheetExtensionWrapper(const QDesignerDynamicPropertySheetExtensionWrapper &) = delete;
    QDesignerDynamicPropertySheetExtensionWrapper& operator=(const QDesignerDynamicPropertySheetExtensionWrapper &) = delete;
    QDesignerDynamicPropertySheetExtensionWrapper(QDesignerDynamicPropertySheetExtensionWrapper &&) = delete;
    QDesignerDynamicPropertySheetExtensionWrapper& operator=(QDesignerDynamicPropertySheetExtensionWrapper &&) = delete;
    ~QDesignerDynamicPropertySheetExtensionWrapper() override;

    int addDynamicProperty(const ::QString & propertyName, const ::QVariant & value) override;
    static int sbk_o_addDynamicProperty(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & propertyName, const ::QVariant & value);
    bool canAddDynamicProperty(const ::QString & propertyName) const override;
    static bool sbk_o_canAddDynamicProperty(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & propertyName);
    bool dynamicPropertiesAllowed() const override;
    bool isDynamicProperty(int index) const override;
    bool removeDynamicProperty(int index) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QDESIGNERDYNAMICPROPERTYSHEETEXTENSIONWRAPPER_H
