// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDESIGNERMEMBERSHEETEXTENSIONWRAPPER_H
#define SBK_QDESIGNERMEMBERSHEETEXTENSIONWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/membersheet.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QDesignerMemberSheetExtensionWrapper : public QDesignerMemberSheetExtension
{
public:
    QDesignerMemberSheetExtensionWrapper() noexcept;
    QDesignerMemberSheetExtensionWrapper(const QDesignerMemberSheetExtensionWrapper &) = delete;
    QDesignerMemberSheetExtensionWrapper& operator=(const QDesignerMemberSheetExtensionWrapper &) = delete;
    QDesignerMemberSheetExtensionWrapper(QDesignerMemberSheetExtensionWrapper &&) = delete;
    QDesignerMemberSheetExtensionWrapper& operator=(QDesignerMemberSheetExtensionWrapper &&) = delete;
    ~QDesignerMemberSheetExtensionWrapper() override;

    int count() const override;
    ::QString declaredInClass(int index) const override;
    int indexOf(const ::QString & name) const override;
    bool inheritedFromWidget(int index) const override;
    bool isSignal(int index) const override;
    bool isSlot(int index) const override;
    bool isVisible(int index) const override;
    ::QString memberGroup(int index) const override;
    ::QString memberName(int index) const override;
    ::QList<QByteArray> parameterNames(int index) const override;
    static ::QList<QByteArray> sbk_o_parameterNames(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int index);
    ::QList<QByteArray> parameterTypes(int index) const override;
    void setMemberGroup(int index, const ::QString & group) override;
    void setVisible(int index, bool b) override;
    ::QString signature(int index) const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[14] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDESIGNERMEMBERSHEETEXTENSIONWRAPPER_H
