// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDESIGNERTASKMENUEXTENSIONWRAPPER_H
#define SBK_QDESIGNERTASKMENUEXTENSIONWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/taskmenu.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QDesignerTaskMenuExtensionWrapper : public QDesignerTaskMenuExtension
{
public:
    QDesignerTaskMenuExtensionWrapper() noexcept;
    QDesignerTaskMenuExtensionWrapper(const QDesignerTaskMenuExtensionWrapper &) = delete;
    QDesignerTaskMenuExtensionWrapper& operator=(const QDesignerTaskMenuExtensionWrapper &) = delete;
    QDesignerTaskMenuExtensionWrapper(QDesignerTaskMenuExtensionWrapper &&) = delete;
    QDesignerTaskMenuExtensionWrapper& operator=(QDesignerTaskMenuExtensionWrapper &&) = delete;
    ~QDesignerTaskMenuExtensionWrapper() override;

    ::QAction * preferredEditAction() const override;
    static ::QAction * sbk_o_preferredEditAction(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QList<QAction*> taskActions() const override;
    static ::QList<QAction*> sbk_o_taskActions(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QDESIGNERTASKMENUEXTENSIONWRAPPER_H
