// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPYDESIGNERPROPERTYSHEETEXTENSIONWRAPPER_H
#define SBK_QPYDESIGNERPROPERTYSHEETEXTENSIONWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qpydesignerextensions.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QPyDesignerPropertySheetExtensionWrapper : public QPyDesignerPropertySheetExtension
{
public:
    QPyDesignerPropertySheetExtensionWrapper(::QObject * parent = nullptr);
    QPyDesignerPropertySheetExtensionWrapper(const QPyDesignerPropertySheetExtensionWrapper &) = delete;
    QPyDesignerPropertySheetExtensionWrapper& operator=(const QPyDesignerPropertySheetExtensionWrapper &) = delete;
    QPyDesignerPropertySheetExtensionWrapper(QPyDesignerPropertySheetExtensionWrapper &&) = delete;
    QPyDesignerPropertySheetExtensionWrapper& operator=(QPyDesignerPropertySheetExtensionWrapper &&) = delete;
    ~QPyDesignerPropertySheetExtensionWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    int count() const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool hasReset(int index) const override;
    int indexOf(const ::QString & name) const override;
    bool isAttribute(int index) const override;
    bool isChanged(int index) const override;
    bool isEnabled(int index) const override;
    bool isVisible(int index) const override;
    ::QVariant property(int index) const override;
    ::QString propertyGroup(int index) const override;
    ::QString propertyName(int index) const override;
    bool reset(int index) override;
    void setAttribute(int index, bool b) override;
    void setChanged(int index, bool changed) override;
    void setProperty(int index, const ::QVariant & value) override;
    void setPropertyGroup(int index, const ::QString & group) override;
    void setVisible(int index, bool b) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[23] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QPYDESIGNERPROPERTYSHEETEXTENSIONWRAPPER_H
