// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCESSIBLEANNOUNCEMENTEVENTWRAPPER_H
#define SBK_QACCESSIBLEANNOUNCEMENTEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccessibleAnnouncementEventWrapper : public QAccessibleAnnouncementEvent
{
public:
    QAccessibleAnnouncementEventWrapper(::QAccessibleInterface * iface, const ::QString & message);
    QAccessibleAnnouncementEventWrapper(::QObject * object, const ::QString & message);
    QAccessibleAnnouncementEventWrapper(const QAccessibleAnnouncementEventWrapper &) = delete;
    QAccessibleAnnouncementEventWrapper& operator=(const QAccessibleAnnouncementEventWrapper &) = delete;
    QAccessibleAnnouncementEventWrapper(QAccessibleAnnouncementEventWrapper &&) = delete;
    QAccessibleAnnouncementEventWrapper& operator=(QAccessibleAnnouncementEventWrapper &&) = delete;
    ~QAccessibleAnnouncementEventWrapper() override;

    ::QAccessibleInterface * accessibleInterface() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QACCESSIBLEANNOUNCEMENTEVENTWRAPPER_H
