// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCESSIBLEEVENTWRAPPER_H
#define SBK_QACCESSIBLEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccessibleEventWrapper : public QAccessibleEvent
{
public:
    QAccessibleEventWrapper(::QAccessibleInterface * iface, ::QAccessible::Event typ);
    QAccessibleEventWrapper(::QObject * obj, ::QAccessible::Event typ);
    QAccessibleEventWrapper(const QAccessibleEventWrapper &) = delete;
    QAccessibleEventWrapper& operator=(const QAccessibleEventWrapper &) = delete;
    QAccessibleEventWrapper(QAccessibleEventWrapper &&) = delete;
    QAccessibleEventWrapper& operator=(QAccessibleEventWrapper &&) = delete;
    ~QAccessibleEventWrapper() override;

    ::QAccessibleInterface * accessibleInterface() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QACCESSIBLEEVENTWRAPPER_H
