// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCESSIBLETABLECELLINTERFACEWRAPPER_H
#define SBK_QACCESSIBLETABLECELLINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccessibleTableCellInterfaceWrapper : public QAccessibleTableCellInterface
{
public:
    QAccessibleTableCellInterfaceWrapper();
    QAccessibleTableCellInterfaceWrapper(const QAccessibleTableCellInterfaceWrapper &) = delete;
    QAccessibleTableCellInterfaceWrapper& operator=(const QAccessibleTableCellInterfaceWrapper &) = delete;
    QAccessibleTableCellInterfaceWrapper(QAccessibleTableCellInterfaceWrapper &&) = delete;
    QAccessibleTableCellInterfaceWrapper& operator=(QAccessibleTableCellInterfaceWrapper &&) = delete;
    ~QAccessibleTableCellInterfaceWrapper() override;

    int columnExtent() const override;
    ::QList<QAccessibleInterface*> columnHeaderCells() const override;
    static ::QList<QAccessibleInterface*> sbk_o_columnHeaderCells(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    int columnIndex() const override;
    bool isSelected() const override;
    int rowExtent() const override;
    ::QList<QAccessibleInterface*> rowHeaderCells() const override;
    int rowIndex() const override;
    ::QAccessibleInterface * table() const override;
    static ::QAccessibleInterface * sbk_o_table(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QACCESSIBLETABLECELLINTERFACEWRAPPER_H
