// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCESSIBLETEXTINSERTEVENTWRAPPER_H
#define SBK_QACCESSIBLETEXTINSERTEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccessibleTextInsertEventWrapper : public QAccessibleTextInsertEvent
{
public:
    QAccessibleTextInsertEventWrapper(::QAccessibleInterface * iface, int position, const ::QString & text);
    QAccessibleTextInsertEventWrapper(::QObject * obj, int position, const ::QString & text);
    QAccessibleTextInsertEventWrapper(const QAccessibleTextInsertEventWrapper &) = delete;
    QAccessibleTextInsertEventWrapper& operator=(const QAccessibleTextInsertEventWrapper &) = delete;
    QAccessibleTextInsertEventWrapper(QAccessibleTextInsertEventWrapper &&) = delete;
    QAccessibleTextInsertEventWrapper& operator=(QAccessibleTextInsertEventWrapper &&) = delete;
    ~QAccessibleTextInsertEventWrapper() override;

    ::QAccessibleInterface * accessibleInterface() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QACCESSIBLETEXTINSERTEVENTWRAPPER_H
