// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCESSIBLETEXTSELECTIONEVENTWRAPPER_H
#define SBK_QACCESSIBLETEXTSELECTIONEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccessibleTextSelectionEventWrapper : public QAccessibleTextSelectionEvent
{
public:
    QAccessibleTextSelectionEventWrapper(::QAccessibleInterface * iface, int start, int end);
    QAccessibleTextSelectionEventWrapper(::QObject * obj, int start, int end);
    QAccessibleTextSelectionEventWrapper(const QAccessibleTextSelectionEventWrapper &) = delete;
    QAccessibleTextSelectionEventWrapper& operator=(const QAccessibleTextSelectionEventWrapper &) = delete;
    QAccessibleTextSelectionEventWrapper(QAccessibleTextSelectionEventWrapper &&) = delete;
    QAccessibleTextSelectionEventWrapper& operator=(QAccessibleTextSelectionEventWrapper &&) = delete;
    ~QAccessibleTextSelectionEventWrapper() override;

    ::QAccessibleInterface * accessibleInterface() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QACCESSIBLETEXTSELECTIONEVENTWRAPPER_H
