// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCESSIBLEVALUECHANGEEVENTWRAPPER_H
#define SBK_QACCESSIBLEVALUECHANGEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccessibleValueChangeEventWrapper : public QAccessibleValueChangeEvent
{
public:
    QAccessibleValueChangeEventWrapper(::QAccessibleInterface * iface, const ::QVariant & val);
    QAccessibleValueChangeEventWrapper(::QObject * obj, const ::QVariant & val);
    QAccessibleValueChangeEventWrapper(const QAccessibleValueChangeEventWrapper &) = delete;
    QAccessibleValueChangeEventWrapper& operator=(const QAccessibleValueChangeEventWrapper &) = delete;
    QAccessibleValueChangeEventWrapper(QAccessibleValueChangeEventWrapper &&) = delete;
    QAccessibleValueChangeEventWrapper& operator=(QAccessibleValueChangeEventWrapper &&) = delete;
    ~QAccessibleValueChangeEventWrapper() override;

    ::QAccessibleInterface * accessibleInterface() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QACCESSIBLEVALUECHANGEEVENTWRAPPER_H
