// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCHILDWINDOWEVENTWRAPPER_H
#define SBK_QCHILDWINDOWEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QChildWindowEventWrapper : public QChildWindowEvent
{
public:
    QChildWindowEventWrapper(::QEvent::Type type, ::QWindow * childWindow);
    QChildWindowEventWrapper(const QChildWindowEventWrapper &) = delete;
    QChildWindowEventWrapper(const QChildWindowEvent& self) : QChildWindowEvent(self)
    {
    }
    QChildWindowEventWrapper& operator=(const QChildWindowEventWrapper &) = delete;
    QChildWindowEventWrapper(QChildWindowEventWrapper &&) = delete;
    QChildWindowEventWrapper& operator=(QChildWindowEventWrapper &&) = delete;
    ~QChildWindowEventWrapper() override;

    ::QChildWindowEvent * clone() const override;
    static ::QChildWindowEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QCHILDWINDOWEVENTWRAPPER_H
