// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCLOSEEVENTWRAPPER_H
#define SBK_QCLOSEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QCloseEventWrapper : public QCloseEvent
{
public:
    QCloseEventWrapper();
    QCloseEventWrapper(const QCloseEventWrapper &) = delete;
    QCloseEventWrapper(const QCloseEvent& self) : QCloseEvent(self)
    {
    }
    QCloseEventWrapper& operator=(const QCloseEventWrapper &) = delete;
    QCloseEventWrapper(QCloseEventWrapper &&) = delete;
    QCloseEventWrapper& operator=(QCloseEventWrapper &&) = delete;
    ~QCloseEventWrapper() override;

    ::QCloseEvent * clone() const override;
    static ::QCloseEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QCLOSEEVENTWRAPPER_H
