// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDRAGENTEREVENTWRAPPER_H
#define SBK_QDRAGENTEREVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QDragEnterEventWrapper : public QDragEnterEvent
{
public:
    QDragEnterEventWrapper(const ::QPoint & pos, ::QFlags<Qt::DropAction> actions, const ::QMimeData * data, ::QFlags<Qt::MouseButton> buttons, ::QFlags<Qt::KeyboardModifier> modifiers);
    QDragEnterEventWrapper(const QDragEnterEventWrapper &) = delete;
    QDragEnterEventWrapper(const QDragEnterEvent& self) : QDragEnterEvent(self)
    {
    }
    QDragEnterEventWrapper& operator=(const QDragEnterEventWrapper &) = delete;
    QDragEnterEventWrapper(QDragEnterEventWrapper &&) = delete;
    QDragEnterEventWrapper& operator=(QDragEnterEventWrapper &&) = delete;
    ~QDragEnterEventWrapper() override;

    ::QDragEnterEvent * clone() const override;
    static ::QDragEnterEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QDRAGENTEREVENTWRAPPER_H
