// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QEXPOSEEVENTWRAPPER_H
#define SBK_QEXPOSEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QExposeEventWrapper : public QExposeEvent
{
public:
    QExposeEventWrapper(const ::QRegion & m_region);
    QExposeEventWrapper(const QExposeEventWrapper &) = delete;
    QExposeEventWrapper(const QExposeEvent& self) : QExposeEvent(self)
    {
    }
    QExposeEventWrapper& operator=(const QExposeEventWrapper &) = delete;
    QExposeEventWrapper(QExposeEventWrapper &&) = delete;
    QExposeEventWrapper& operator=(QExposeEventWrapper &&) = delete;
    ~QExposeEventWrapper() override;

    ::QExposeEvent * clone() const override;
    static ::QExposeEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QEXPOSEEVENTWRAPPER_H
