// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFILEOPENEVENTWRAPPER_H
#define SBK_QFILEOPENEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QFileOpenEventWrapper : public QFileOpenEvent
{
public:
    QFileOpenEventWrapper(const ::QString & file);
    QFileOpenEventWrapper(const ::QUrl & url);
    QFileOpenEventWrapper(const QFileOpenEventWrapper &) = delete;
    QFileOpenEventWrapper(const QFileOpenEvent& self) : QFileOpenEvent(self)
    {
    }
    QFileOpenEventWrapper& operator=(const QFileOpenEventWrapper &) = delete;
    QFileOpenEventWrapper(QFileOpenEventWrapper &&) = delete;
    QFileOpenEventWrapper& operator=(QFileOpenEventWrapper &&) = delete;
    ~QFileOpenEventWrapper() override;

    ::QFileOpenEvent * clone() const override;
    static ::QFileOpenEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QFILEOPENEVENTWRAPPER_H
