// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QHELPEVENTWRAPPER_H
#define SBK_QHELPEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QHelpEventWrapper : public QHelpEvent
{
public:
    QHelpEventWrapper(::QEvent::Type type, const ::QPoint & pos, const ::QPoint & globalPos);
    QHelpEventWrapper(const QHelpEventWrapper &) = delete;
    QHelpEventWrapper(const QHelpEvent& self) : QHelpEvent(self)
    {
    }
    QHelpEventWrapper& operator=(const QHelpEventWrapper &) = delete;
    QHelpEventWrapper(QHelpEventWrapper &&) = delete;
    QHelpEventWrapper& operator=(QHelpEventWrapper &&) = delete;
    ~QHelpEventWrapper() override;

    ::QHelpEvent * clone() const override;
    static ::QHelpEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QHELPEVENTWRAPPER_H
