// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QINPUTMETHODQUERYEVENTWRAPPER_H
#define SBK_QINPUTMETHODQUERYEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QInputMethodQueryEventWrapper : public QInputMethodQueryEvent
{
public:
    QInputMethodQueryEventWrapper(::QFlags<Qt::InputMethodQuery> queries);
    QInputMethodQueryEventWrapper(const QInputMethodQueryEventWrapper &) = delete;
    QInputMethodQueryEventWrapper(const QInputMethodQueryEvent& self) : QInputMethodQueryEvent(self)
    {
    }
    QInputMethodQueryEventWrapper& operator=(const QInputMethodQueryEventWrapper &) = delete;
    QInputMethodQueryEventWrapper(QInputMethodQueryEventWrapper &&) = delete;
    QInputMethodQueryEventWrapper& operator=(QInputMethodQueryEventWrapper &&) = delete;
    ~QInputMethodQueryEventWrapper() override;

    ::QInputMethodQueryEvent * clone() const override;
    static ::QInputMethodQueryEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QINPUTMETHODQUERYEVENTWRAPPER_H
