// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMOVEEVENTWRAPPER_H
#define SBK_QMOVEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QMoveEventWrapper : public QMoveEvent
{
public:
    QMoveEventWrapper(const ::QPoint & pos, const ::QPoint & oldPos);
    QMoveEventWrapper(const QMoveEventWrapper &) = delete;
    QMoveEventWrapper(const QMoveEvent& self) : QMoveEvent(self)
    {
    }
    QMoveEventWrapper& operator=(const QMoveEventWrapper &) = delete;
    QMoveEventWrapper(QMoveEventWrapper &&) = delete;
    QMoveEventWrapper& operator=(QMoveEventWrapper &&) = delete;
    ~QMoveEventWrapper() override;

    ::QMoveEvent * clone() const override;
    static ::QMoveEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QMOVEEVENTWRAPPER_H
