// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMOVIEWRAPPER_H
#define SBK_QMOVIEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qmovie.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QMovieWrapper : public QMovie
{
public:
    QMovieWrapper(::QIODevice * device, const ::QByteArray & format = QByteArray(), ::QObject * parent = nullptr);
    QMovieWrapper(::QObject * parent = nullptr);
    QMovieWrapper(const ::QString & fileName, const ::QByteArray & format = QByteArray(), ::QObject * parent = nullptr);
    QMovieWrapper(const QMovieWrapper &) = delete;
    QMovieWrapper& operator=(const QMovieWrapper &) = delete;
    QMovieWrapper(QMovieWrapper &&) = delete;
    QMovieWrapper& operator=(QMovieWrapper &&) = delete;
    ~QMovieWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QMOVIEWRAPPER_H
