// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPAINTEVENTWRAPPER_H
#define SBK_QPAINTEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QPaintEventWrapper : public QPaintEvent
{
public:
    QPaintEventWrapper(const ::QRect & paintRect);
    QPaintEventWrapper(const ::QRegion & paintRegion);
    QPaintEventWrapper(const QPaintEventWrapper &) = delete;
    QPaintEventWrapper(const QPaintEvent& self) : QPaintEvent(self)
    {
    }
    QPaintEventWrapper& operator=(const QPaintEventWrapper &) = delete;
    QPaintEventWrapper(QPaintEventWrapper &&) = delete;
    QPaintEventWrapper& operator=(QPaintEventWrapper &&) = delete;
    ~QPaintEventWrapper() override;

    ::QPaintEvent * clone() const override;
    static ::QPaintEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QPAINTEVENTWRAPPER_H
