// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRHIGRAPHICSPIPELINEWRAPPER_H
#define SBK_QRHIGRAPHICSPIPELINEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRhiGraphicsPipelineWrapper : public QRhiGraphicsPipeline
{
public:
    QRhiGraphicsPipelineWrapper(const QRhiGraphicsPipelineWrapper &) = delete;
    QRhiGraphicsPipelineWrapper& operator=(const QRhiGraphicsPipelineWrapper &) = delete;
    QRhiGraphicsPipelineWrapper(QRhiGraphicsPipelineWrapper &&) = delete;
    QRhiGraphicsPipelineWrapper& operator=(QRhiGraphicsPipelineWrapper &&) = delete;
    ~QRhiGraphicsPipelineWrapper() override;

    bool create() override;
    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QRHIGRAPHICSPIPELINEWRAPPER_H
