// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRHIRENDERBUFFERWRAPPER_H
#define SBK_QRHIRENDERBUFFERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRhiRenderBufferWrapper : public QRhiRenderBuffer
{
public:
    QRhiRenderBufferWrapper(const QRhiRenderBufferWrapper &) = delete;
    QRhiRenderBufferWrapper& operator=(const QRhiRenderBufferWrapper &) = delete;
    QRhiRenderBufferWrapper(QRhiRenderBufferWrapper &&) = delete;
    QRhiRenderBufferWrapper& operator=(QRhiRenderBufferWrapper &&) = delete;
    ~QRhiRenderBufferWrapper() override;

    ::QRhiTexture::Format backingFormat() const override;
    static ::QRhiTexture::Format sbk_o_backingFormat(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    bool create() override;
    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[4] = {false, false, false, false};
};

#endif // SBK_QRHIRENDERBUFFERWRAPPER_H
