// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRHIRENDERPASSDESCRIPTORWRAPPER_H
#define SBK_QRHIRENDERPASSDESCRIPTORWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRhiRenderPassDescriptorWrapper : public QRhiRenderPassDescriptor
{
public:
    QRhiRenderPassDescriptorWrapper(const QRhiRenderPassDescriptorWrapper &) = delete;
    QRhiRenderPassDescriptorWrapper& operator=(const QRhiRenderPassDescriptorWrapper &) = delete;
    QRhiRenderPassDescriptorWrapper(QRhiRenderPassDescriptorWrapper &&) = delete;
    QRhiRenderPassDescriptorWrapper& operator=(QRhiRenderPassDescriptorWrapper &&) = delete;
    ~QRhiRenderPassDescriptorWrapper() override;

    void destroy() override;
    bool isCompatible(const ::QRhiRenderPassDescriptor * other) const override;
    static bool sbk_o_isCompatible(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QRhiRenderPassDescriptor * other);
    const ::QRhiNativeHandles * nativeHandles() override;
    static const ::QRhiNativeHandles * sbk_o_nativeHandles(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QRhiRenderPassDescriptor * newCompatibleRenderPassDescriptor() const override;
    static ::QRhiRenderPassDescriptor * sbk_o_newCompatibleRenderPassDescriptor(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QRhiResource::Type resourceType() const override;
    ::QList<quint32> serializedFormat() const override;
    static ::QList<quint32> sbk_o_serializedFormat(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_QRHIRENDERPASSDESCRIPTORWRAPPER_H
