// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRHIRENDERTARGETWRAPPER_H
#define SBK_QRHIRENDERTARGETWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRhiRenderTargetWrapper : public QRhiRenderTarget
{
public:
    QRhiRenderTargetWrapper(const QRhiRenderTargetWrapper &) = delete;
    QRhiRenderTargetWrapper& operator=(const QRhiRenderTargetWrapper &) = delete;
    QRhiRenderTargetWrapper(QRhiRenderTargetWrapper &&) = delete;
    QRhiRenderTargetWrapper& operator=(QRhiRenderTargetWrapper &&) = delete;
    ~QRhiRenderTargetWrapper() override;

    void destroy() override;
    float devicePixelRatio() const override;
    static float sbk_o_devicePixelRatio(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QSize pixelSize() const override;
    ::QRhiResource::Type resourceType() const override;
    int sampleCount() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QRHIRENDERTARGETWRAPPER_H
