// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRHIRESOURCEWRAPPER_H
#define SBK_QRHIRESOURCEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRhiResourceWrapper : public QRhiResource
{
public:
    QRhiResourceWrapper(const QRhiResourceWrapper &) = delete;
    QRhiResourceWrapper& operator=(const QRhiResourceWrapper &) = delete;
    QRhiResourceWrapper(QRhiResourceWrapper &&) = delete;
    QRhiResourceWrapper& operator=(QRhiResourceWrapper &&) = delete;
    ~QRhiResourceWrapper() override;

    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    static ::QRhiResource::Type sbk_o_resourceType(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QRHIRESOURCEWRAPPER_H
