// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRHISWAPCHAINRENDERTARGETWRAPPER_H
#define SBK_QRHISWAPCHAINRENDERTARGETWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRhiSwapChainRenderTargetWrapper : public QRhiSwapChainRenderTarget
{
public:
    QRhiSwapChainRenderTargetWrapper(const QRhiSwapChainRenderTargetWrapper &) = delete;
    QRhiSwapChainRenderTargetWrapper& operator=(const QRhiSwapChainRenderTargetWrapper &) = delete;
    QRhiSwapChainRenderTargetWrapper(QRhiSwapChainRenderTargetWrapper &&) = delete;
    QRhiSwapChainRenderTargetWrapper& operator=(QRhiSwapChainRenderTargetWrapper &&) = delete;
    ~QRhiSwapChainRenderTargetWrapper() override;

    void destroy() override;
    float devicePixelRatio() const override;
    ::QSize pixelSize() const override;
    ::QRhiResource::Type resourceType() const override;
    int sampleCount() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QRHISWAPCHAINRENDERTARGETWRAPPER_H
