// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRHITEXTURERENDERTARGETWRAPPER_H
#define SBK_QRHITEXTURERENDERTARGETWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRhiTextureRenderTargetWrapper : public QRhiTextureRenderTarget
{
public:
    QRhiTextureRenderTargetWrapper(const QRhiTextureRenderTargetWrapper &) = delete;
    QRhiTextureRenderTargetWrapper& operator=(const QRhiTextureRenderTargetWrapper &) = delete;
    QRhiTextureRenderTargetWrapper(QRhiTextureRenderTargetWrapper &&) = delete;
    QRhiTextureRenderTargetWrapper& operator=(QRhiTextureRenderTargetWrapper &&) = delete;
    ~QRhiTextureRenderTargetWrapper() override;

    bool create() override;
    void destroy() override;
    float devicePixelRatio() const override;
    ::QRhiRenderPassDescriptor * newCompatibleRenderPassDescriptor() override;
    ::QSize pixelSize() const override;
    ::QRhiResource::Type resourceType() const override;
    int sampleCount() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QRHITEXTURERENDERTARGETWRAPPER_H
