// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSCROLLEVENTWRAPPER_H
#define SBK_QSCROLLEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QScrollEventWrapper : public QScrollEvent
{
public:
    QScrollEventWrapper(const ::QPointF & contentPos, const ::QPointF & overshoot, ::QScrollEvent::ScrollState scrollState);
    QScrollEventWrapper(const QScrollEventWrapper &) = delete;
    QScrollEventWrapper(const QScrollEvent& self) : QScrollEvent(self)
    {
    }
    QScrollEventWrapper& operator=(const QScrollEventWrapper &) = delete;
    QScrollEventWrapper(QScrollEventWrapper &&) = delete;
    QScrollEventWrapper& operator=(QScrollEventWrapper &&) = delete;
    ~QScrollEventWrapper() override;

    ::QScrollEvent * clone() const override;
    static ::QScrollEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSCROLLEVENTWRAPPER_H
