// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSCROLLPREPAREEVENTWRAPPER_H
#define SBK_QSCROLLPREPAREEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QScrollPrepareEventWrapper : public QScrollPrepareEvent
{
public:
    QScrollPrepareEventWrapper(const ::QPointF & startPos);
    QScrollPrepareEventWrapper(const QScrollPrepareEventWrapper &) = delete;
    QScrollPrepareEventWrapper(const QScrollPrepareEvent& self) : QScrollPrepareEvent(self)
    {
    }
    QScrollPrepareEventWrapper& operator=(const QScrollPrepareEventWrapper &) = delete;
    QScrollPrepareEventWrapper(QScrollPrepareEventWrapper &&) = delete;
    QScrollPrepareEventWrapper& operator=(QScrollPrepareEventWrapper &&) = delete;
    ~QScrollPrepareEventWrapper() override;

    ::QScrollPrepareEvent * clone() const override;
    static ::QScrollPrepareEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSCROLLPREPAREEVENTWRAPPER_H
