// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTEXTOBJECTINTERFACEWRAPPER_H
#define SBK_QTEXTOBJECTINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qabstracttextdocumentlayout.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QTextObjectInterfaceWrapper : public QTextObjectInterface
{
public:
    QTextObjectInterfaceWrapper();
    QTextObjectInterfaceWrapper(const QTextObjectInterfaceWrapper &) = delete;
    QTextObjectInterfaceWrapper& operator=(const QTextObjectInterfaceWrapper &) = delete;
    QTextObjectInterfaceWrapper(QTextObjectInterfaceWrapper &&) = delete;
    QTextObjectInterfaceWrapper& operator=(QTextObjectInterfaceWrapper &&) = delete;
    ~QTextObjectInterfaceWrapper() override;

    void drawObject(::QPainter * painter, const ::QRectF & rect, ::QTextDocument * doc, int posInDocument, const ::QTextFormat & format) override;
    static void sbk_o_drawObject(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QPainter * painter, const ::QRectF & rect, ::QTextDocument * doc, int posInDocument, const ::QTextFormat & format);
    ::QSizeF intrinsicSize(::QTextDocument * doc, int posInDocument, const ::QTextFormat & format) override;
    static ::QSizeF sbk_o_intrinsicSize(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QTextDocument * doc, int posInDocument, const ::QTextFormat & format);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QTEXTOBJECTINTERFACEWRAPPER_H
