// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QVALIDATORWRAPPER_H
#define SBK_QVALIDATORWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qvalidator.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QValidatorWrapper : public QValidator
{
public:
    QValidatorWrapper(::QObject * parent = nullptr);
    QValidatorWrapper(const QValidatorWrapper &) = delete;
    QValidatorWrapper& operator=(const QValidatorWrapper &) = delete;
    QValidatorWrapper(QValidatorWrapper &&) = delete;
    QValidatorWrapper& operator=(QValidatorWrapper &&) = delete;
    ~QValidatorWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void fixup(::QString & arg__1) const override;
    static void sbk_o_fixup(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QString & arg__1);
    void timerEvent(::QTimerEvent * event) override;
    ::QValidator::State validate(::QString & arg__1, int & arg__2) const override;
    static ::QValidator::State sbk_o_validate(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QString & arg__1, int & arg__2);

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QVALIDATORWRAPPER_H
