// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPLACERESULTWRAPPER_H
#define SBK_QPLACERESULTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qplaceresult.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QPlaceResultWrapper : public QPlaceResult
{
public:
    QPlaceResultWrapper();
    QPlaceResultWrapper(const ::QPlaceSearchResult & other);
    QPlaceResultWrapper(const QPlaceResultWrapper &) = delete;
    QPlaceResultWrapper& operator=(const QPlaceResultWrapper &) = delete;
    QPlaceResultWrapper(QPlaceResultWrapper &&) = delete;
    QPlaceResultWrapper& operator=(QPlaceResultWrapper &&) = delete;
    ~QPlaceResultWrapper() override;

    static void pysideInitQtMetaTypes();

private:
};

#endif // SBK_QPLACERESULTWRAPPER_H
