// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QABSTRACTVIDEOBUFFERWRAPPER_H
#define SBK_QABSTRACTVIDEOBUFFERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtMultimedia/qabstractvideobuffer.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAbstractVideoBufferWrapper : public QAbstractVideoBuffer
{
public:
    QAbstractVideoBufferWrapper();
    QAbstractVideoBufferWrapper(const QAbstractVideoBufferWrapper &) = delete;
    QAbstractVideoBufferWrapper& operator=(const QAbstractVideoBufferWrapper &) = delete;
    QAbstractVideoBufferWrapper(QAbstractVideoBufferWrapper &&) = delete;
    QAbstractVideoBufferWrapper& operator=(QAbstractVideoBufferWrapper &&) = delete;
    ~QAbstractVideoBufferWrapper() override;

    ::QVideoFrameFormat format() const override;
    static ::QVideoFrameFormat sbk_o_format(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QAbstractVideoBuffer::MapData map(::QVideoFrame::MapMode mode) override;
    static ::QAbstractVideoBuffer::MapData sbk_o_map(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QVideoFrame::MapMode mode);
    void unmap() override;
    static void sbk_o_unmap(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QABSTRACTVIDEOBUFFERWRAPPER_H
