// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QNETWORKPROXYFACTORYWRAPPER_H
#define SBK_QNETWORKPROXYFACTORYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qnetworkproxy.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QNetworkProxyFactoryWrapper : public QNetworkProxyFactory
{
public:
    QNetworkProxyFactoryWrapper();
    QNetworkProxyFactoryWrapper(const QNetworkProxyFactoryWrapper &) = delete;
    QNetworkProxyFactoryWrapper& operator=(const QNetworkProxyFactoryWrapper &) = delete;
    QNetworkProxyFactoryWrapper(QNetworkProxyFactoryWrapper &&) = delete;
    QNetworkProxyFactoryWrapper& operator=(QNetworkProxyFactoryWrapper &&) = delete;
    ~QNetworkProxyFactoryWrapper() override;

    ::QList<QNetworkProxy> queryProxy(const ::QNetworkProxyQuery & query = QNetworkProxyQuery()) override;
    static ::QList<QNetworkProxy> sbk_o_queryProxy(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QNetworkProxyQuery & query = QNetworkProxyQuery());
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QNETWORKPROXYFACTORYWRAPPER_H
