// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOPENGLFUNCTIONS_2_0WRAPPER_H
#define SBK_QOPENGLFUNCTIONS_2_0WRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglfunctions_2_0.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QOpenGLFunctions_2_0Wrapper : public QOpenGLFunctions_2_0
{
public:
    QOpenGLFunctions_2_0Wrapper();
    QOpenGLFunctions_2_0Wrapper(const QOpenGLFunctions_2_0Wrapper &) = delete;
    QOpenGLFunctions_2_0Wrapper& operator=(const QOpenGLFunctions_2_0Wrapper &) = delete;
    QOpenGLFunctions_2_0Wrapper(QOpenGLFunctions_2_0Wrapper &&) = delete;
    QOpenGLFunctions_2_0Wrapper& operator=(QOpenGLFunctions_2_0Wrapper &&) = delete;
    ~QOpenGLFunctions_2_0Wrapper() override;

    bool initializeOpenGLFunctions() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QOPENGLFUNCTIONS_2_0WRAPPER_H
