// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGEOSATELLITEINFOSOURCEWRAPPER_H
#define SBK_QGEOSATELLITEINFOSOURCEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtPositioning/qgeosatelliteinfosource.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QGeoSatelliteInfoSourceWrapper : public QGeoSatelliteInfoSource
{
public:
    QGeoSatelliteInfoSourceWrapper(::QObject * parent);
    QGeoSatelliteInfoSourceWrapper(const QGeoSatelliteInfoSourceWrapper &) = delete;
    QGeoSatelliteInfoSourceWrapper& operator=(const QGeoSatelliteInfoSourceWrapper &) = delete;
    QGeoSatelliteInfoSourceWrapper(QGeoSatelliteInfoSourceWrapper &&) = delete;
    QGeoSatelliteInfoSourceWrapper& operator=(QGeoSatelliteInfoSourceWrapper &&) = delete;
    ~QGeoSatelliteInfoSourceWrapper() override;

    ::QVariant backendProperty(const ::QString & name) const override;
    static ::QVariant sbk_o_backendProperty(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & name);
    void childEvent(::QChildEvent * event) override;
    static void sbk_o_childEvent(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QChildEvent * event);
    void connectNotify(const ::QMetaMethod & signal) override;
    static void sbk_o_connectNotify(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QMetaMethod & signal);
    void customEvent(::QEvent * event) override;
    static void sbk_o_customEvent(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QEvent * event);
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QGeoSatelliteInfoSource::Error error() const override;
    static ::QGeoSatelliteInfoSource::Error sbk_o_error(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    bool event(::QEvent * event) override;
    static bool sbk_o_event(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QEvent * event);
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    static bool sbk_o_eventFilter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * watched, ::QEvent * event);
    int minimumUpdateInterval() const override;
    static int sbk_o_minimumUpdateInterval(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void requestUpdate(int timeout = 0) override;
    static void sbk_o_requestUpdate(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int timeout = 0);
    bool setBackendProperty(const ::QString & name, const ::QVariant & value) override;
    static bool sbk_o_setBackendProperty(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & name, const ::QVariant & value);
    void setUpdateInterval(int msec) override;
    void startUpdates() override;
    static void sbk_o_startUpdates(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void stopUpdates() override;
    void timerEvent(::QTimerEvent * event) override;
    static void sbk_o_timerEvent(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QTimerEvent * event);

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[15] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QGEOSATELLITEINFOSOURCEWRAPPER_H
