// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPRINTENGINEWRAPPER_H
#define SBK_QPRINTENGINEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtPrintSupport/qprintengine.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QPrintEngineWrapper : public QPrintEngine
{
public:
    QPrintEngineWrapper();
    QPrintEngineWrapper(const QPrintEngineWrapper &) = delete;
    QPrintEngineWrapper& operator=(const QPrintEngineWrapper &) = delete;
    QPrintEngineWrapper(QPrintEngineWrapper &&) = delete;
    QPrintEngineWrapper& operator=(QPrintEngineWrapper &&) = delete;
    ~QPrintEngineWrapper() override;

    bool abort() override;
    static bool sbk_o_abort(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    int metric(::QPaintDevice::PaintDeviceMetric arg__1) const override;
    static int sbk_o_metric(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QPaintDevice::PaintDeviceMetric arg__1);
    bool newPage() override;
    ::QPrinter::PrinterState printerState() const override;
    static ::QPrinter::PrinterState sbk_o_printerState(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QVariant property(::QPrintEngine::PrintEnginePropertyKey key) const override;
    static ::QVariant sbk_o_property(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QPrintEngine::PrintEnginePropertyKey key);
    void setProperty(::QPrintEngine::PrintEnginePropertyKey key, const ::QVariant & value) override;
    static void sbk_o_setProperty(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QPrintEngine::PrintEnginePropertyKey key, const ::QVariant & value);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_QPRINTENGINEWRAPPER_H
