// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQMLEXTENSIONINTERFACEWRAPPER_H
#define SBK_QQMLEXTENSIONINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlextensioninterface.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QQmlExtensionInterfaceWrapper : public QQmlExtensionInterface
{
public:
    QQmlExtensionInterfaceWrapper();
    QQmlExtensionInterfaceWrapper(const QQmlExtensionInterfaceWrapper &) = delete;
    QQmlExtensionInterfaceWrapper& operator=(const QQmlExtensionInterfaceWrapper &) = delete;
    QQmlExtensionInterfaceWrapper(QQmlExtensionInterfaceWrapper &&) = delete;
    QQmlExtensionInterfaceWrapper& operator=(QQmlExtensionInterfaceWrapper &&) = delete;
    ~QQmlExtensionInterfaceWrapper() override;

    void initializeEngine(::QQmlEngine * engine, const char * uri) override;
    static void sbk_o_initializeEngine(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QQmlEngine * engine, const char * uri);
    void registerTypes(const char * uri) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QQMLEXTENSIONINTERFACEWRAPPER_H
