// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQMLIMAGEPROVIDERBASEWRAPPER_H
#define SBK_QQMLIMAGEPROVIDERBASEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlengine.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QQmlImageProviderBaseWrapper : public QQmlImageProviderBase
{
public:
    QQmlImageProviderBaseWrapper(const QQmlImageProviderBaseWrapper &) = delete;
    QQmlImageProviderBaseWrapper& operator=(const QQmlImageProviderBaseWrapper &) = delete;
    QQmlImageProviderBaseWrapper(QQmlImageProviderBaseWrapper &&) = delete;
    QQmlImageProviderBaseWrapper& operator=(QQmlImageProviderBaseWrapper &&) = delete;
    ~QQmlImageProviderBaseWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QFlags<QQmlImageProviderBase::Flag> flags() const override;
    static ::QFlags<QQmlImageProviderBase::Flag> sbk_o_flags(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QQmlImageProviderBase::ImageType imageType() const override;
    static ::QQmlImageProviderBase::ImageType sbk_o_imageType(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQMLIMAGEPROVIDERBASEWRAPPER_H
