// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQMLINCUBATORWRAPPER_H
#define SBK_QQMLINCUBATORWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlincubator.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QQmlIncubatorWrapper : public QQmlIncubator
{
public:
    QQmlIncubatorWrapper(::QQmlIncubator::IncubationMode arg__1 = QQmlIncubator::IncubationMode::Asynchronous);
    QQmlIncubatorWrapper(const QQmlIncubatorWrapper &) = delete;
    QQmlIncubatorWrapper& operator=(const QQmlIncubatorWrapper &) = delete;
    QQmlIncubatorWrapper(QQmlIncubatorWrapper &&) = delete;
    QQmlIncubatorWrapper& operator=(QQmlIncubatorWrapper &&) = delete;
    ~QQmlIncubatorWrapper() override;

    void setInitialState(::QObject * arg__1) override;
    static void sbk_o_setInitialState(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * arg__1);
    void statusChanged(::QQmlIncubator::Status arg__1) override;
    static void sbk_o_statusChanged(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QQmlIncubator::Status arg__1);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QQMLINCUBATORWRAPPER_H
