// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQMLPROPERTYVALUESOURCEWRAPPER_H
#define SBK_QQMLPROPERTYVALUESOURCEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlpropertyvaluesource.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QQmlPropertyValueSourceWrapper : public QQmlPropertyValueSource
{
public:
    QQmlPropertyValueSourceWrapper();
    QQmlPropertyValueSourceWrapper(const QQmlPropertyValueSourceWrapper &) = delete;
    QQmlPropertyValueSourceWrapper& operator=(const QQmlPropertyValueSourceWrapper &) = delete;
    QQmlPropertyValueSourceWrapper(QQmlPropertyValueSourceWrapper &&) = delete;
    QQmlPropertyValueSourceWrapper& operator=(QQmlPropertyValueSourceWrapper &&) = delete;
    ~QQmlPropertyValueSourceWrapper() override;

    void setTarget(const ::QQmlProperty & arg__1) override;
    static void sbk_o_setTarget(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QQmlProperty & arg__1);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QQMLPROPERTYVALUESOURCEWRAPPER_H
