// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_RENDERERWRAPPER_H
#define SBK_RENDERERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickframebufferobject.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class RendererWrapper : public QQuickFramebufferObject::Renderer
{
public:
    RendererWrapper();
    RendererWrapper(const RendererWrapper &) = delete;
    RendererWrapper& operator=(const RendererWrapper &) = delete;
    RendererWrapper(RendererWrapper &&) = delete;
    RendererWrapper& operator=(RendererWrapper &&) = delete;
    ~RendererWrapper() override;

    ::QOpenGLFramebufferObject * createFramebufferObject(const ::QSize & size) override;
    static ::QOpenGLFramebufferObject * sbk_o_createFramebufferObject(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QSize & size);
    void render() override;
    void synchronize(::QQuickFramebufferObject * arg__1) override;
    static void sbk_o_synchronize(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QQuickFramebufferObject * arg__1);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_RENDERERWRAPPER_H
