// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQUICKTEXTUREFACTORYWRAPPER_H
#define SBK_QQUICKTEXTUREFACTORYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickimageprovider.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QQuickTextureFactoryWrapper : public QQuickTextureFactory
{
public:
    QQuickTextureFactoryWrapper();
    QQuickTextureFactoryWrapper(const QQuickTextureFactoryWrapper &) = delete;
    QQuickTextureFactoryWrapper& operator=(const QQuickTextureFactoryWrapper &) = delete;
    QQuickTextureFactoryWrapper(QQuickTextureFactoryWrapper &&) = delete;
    QQuickTextureFactoryWrapper& operator=(QQuickTextureFactoryWrapper &&) = delete;
    ~QQuickTextureFactoryWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QSGTexture * createTexture(::QQuickWindow * window) const override;
    static ::QSGTexture * sbk_o_createTexture(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QQuickWindow * window);
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QImage image() const override;
    static ::QImage sbk_o_image(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    int textureByteCount() const override;
    ::QSize textureSize() const override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[11] = {false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQUICKTEXTUREFACTORYWRAPPER_H
