// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGMATERIALWRAPPER_H
#define SBK_QSGMATERIALWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgmaterial.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGMaterialWrapper : public QSGMaterial
{
public:
    QSGMaterialWrapper();
    QSGMaterialWrapper(const QSGMaterialWrapper &) = delete;
    QSGMaterialWrapper& operator=(const QSGMaterialWrapper &) = delete;
    QSGMaterialWrapper(QSGMaterialWrapper &&) = delete;
    QSGMaterialWrapper& operator=(QSGMaterialWrapper &&) = delete;
    ~QSGMaterialWrapper() override;

    int compare(const ::QSGMaterial * other) const override;
    static int sbk_o_compare(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QSGMaterial * other);
    ::QSGMaterialShader * createShader(::QSGRendererInterface::RenderMode renderMode) const override;
    static ::QSGMaterialShader * sbk_o_createShader(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSGRendererInterface::RenderMode renderMode);
    ::QSGMaterialType * type() const override;
    static ::QSGMaterialType * sbk_o_type(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QSGMATERIALWRAPPER_H
