// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGMATERIALSHADERWRAPPER_H
#define SBK_QSGMATERIALSHADERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgmaterialshader.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGMaterialShaderWrapper : public QSGMaterialShader
{
public:
    QSGMaterialShaderWrapper();
    QSGMaterialShaderWrapper(const QSGMaterialShaderWrapper &) = delete;
    QSGMaterialShaderWrapper& operator=(const QSGMaterialShaderWrapper &) = delete;
    QSGMaterialShaderWrapper(QSGMaterialShaderWrapper &&) = delete;
    QSGMaterialShaderWrapper& operator=(QSGMaterialShaderWrapper &&) = delete;
    ~QSGMaterialShaderWrapper() override;

    bool updateGraphicsPipelineState(::QSGMaterialShader::RenderState & state, ::QSGMaterialShader::GraphicsPipelineState * ps, ::QSGMaterial * newMaterial, ::QSGMaterial * oldMaterial) override;
    static bool sbk_o_updateGraphicsPipelineState(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSGMaterialShader::RenderState & state, ::QSGMaterialShader::GraphicsPipelineState * ps, ::QSGMaterial * newMaterial, ::QSGMaterial * oldMaterial);
    bool updateUniformData(::QSGMaterialShader::RenderState & state, ::QSGMaterial * newMaterial, ::QSGMaterial * oldMaterial) override;
    static bool sbk_o_updateUniformData(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSGMaterialShader::RenderState & state, ::QSGMaterial * newMaterial, ::QSGMaterial * oldMaterial);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSGMATERIALSHADERWRAPPER_H
