// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGNINEPATCHNODEWRAPPER_H
#define SBK_QSGNINEPATCHNODEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgninepatchnode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGNinePatchNodeWrapper : public QSGNinePatchNode
{
public:
    QSGNinePatchNodeWrapper();
    QSGNinePatchNodeWrapper(const QSGNinePatchNodeWrapper &) = delete;
    QSGNinePatchNodeWrapper& operator=(const QSGNinePatchNodeWrapper &) = delete;
    QSGNinePatchNodeWrapper(QSGNinePatchNodeWrapper &&) = delete;
    QSGNinePatchNodeWrapper& operator=(QSGNinePatchNodeWrapper &&) = delete;
    ~QSGNinePatchNodeWrapper() override;

    bool isSubtreeBlocked() const override;
    void preprocess() override;
    void setBounds(const ::QRectF & bounds) override;
    void setDevicePixelRatio(qreal ratio) override;
    static void sbk_o_setDevicePixelRatio(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, qreal ratio);
    void setPadding(qreal left, qreal top, qreal right, qreal bottom) override;
    static void sbk_o_setPadding(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, qreal left, qreal top, qreal right, qreal bottom);
    void setTexture(::QSGTexture * texture) override;
    static void sbk_o_setTexture(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSGTexture * texture);
    void update() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QSGNINEPATCHNODEWRAPPER_H
