// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGNODEVISITORWRAPPER_H
#define SBK_QSGNODEVISITORWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgnode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGNodeVisitorWrapper : public QSGNodeVisitor
{
public:
    QSGNodeVisitorWrapper();
    QSGNodeVisitorWrapper(const QSGNodeVisitorWrapper &) = delete;
    QSGNodeVisitorWrapper& operator=(const QSGNodeVisitorWrapper &) = delete;
    QSGNodeVisitorWrapper(QSGNodeVisitorWrapper &&) = delete;
    QSGNodeVisitorWrapper& operator=(QSGNodeVisitorWrapper &&) = delete;
    ~QSGNodeVisitorWrapper() override;

    void enterClipNode(::QSGClipNode * arg__1) override;
    static void sbk_o_enterClipNode(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSGClipNode * arg__1);
    void enterGeometryNode(::QSGGeometryNode * arg__1) override;
    static void sbk_o_enterGeometryNode(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSGGeometryNode * arg__1);
    void enterOpacityNode(::QSGOpacityNode * arg__1) override;
    static void sbk_o_enterOpacityNode(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSGOpacityNode * arg__1);
    void enterTransformNode(::QSGTransformNode * arg__1) override;
    static void sbk_o_enterTransformNode(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSGTransformNode * arg__1);
    void leaveClipNode(::QSGClipNode * arg__1) override;
    void leaveGeometryNode(::QSGGeometryNode * arg__1) override;
    void leaveOpacityNode(::QSGOpacityNode * arg__1) override;
    void leaveTransformNode(::QSGTransformNode * arg__1) override;
    void visitChildren(::QSGNode * n) override;
    static void sbk_o_visitChildren(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSGNode * n);
    void visitNode(::QSGNode * n) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QSGNODEVISITORWRAPPER_H
