// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGOPACITYNODEWRAPPER_H
#define SBK_QSGOPACITYNODEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgnode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGOpacityNodeWrapper : public QSGOpacityNode
{
public:
    QSGOpacityNodeWrapper();
    QSGOpacityNodeWrapper(const QSGOpacityNodeWrapper &) = delete;
    QSGOpacityNodeWrapper& operator=(const QSGOpacityNodeWrapper &) = delete;
    QSGOpacityNodeWrapper(QSGOpacityNodeWrapper &&) = delete;
    QSGOpacityNodeWrapper& operator=(QSGOpacityNodeWrapper &&) = delete;
    ~QSGOpacityNodeWrapper() override;

    bool isSubtreeBlocked() const override;
    void preprocess() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSGOPACITYNODEWRAPPER_H
