// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGROOTNODEWRAPPER_H
#define SBK_QSGROOTNODEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgnode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGRootNodeWrapper : public QSGRootNode
{
public:
    QSGRootNodeWrapper();
    QSGRootNodeWrapper(const QSGRootNodeWrapper &) = delete;
    QSGRootNodeWrapper& operator=(const QSGRootNodeWrapper &) = delete;
    QSGRootNodeWrapper(QSGRootNodeWrapper &&) = delete;
    QSGRootNodeWrapper& operator=(QSGRootNodeWrapper &&) = delete;
    ~QSGRootNodeWrapper() override;

    bool isSubtreeBlocked() const override;
    void preprocess() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSGROOTNODEWRAPPER_H
