// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGVERTEXCOLORMATERIALWRAPPER_H
#define SBK_QSGVERTEXCOLORMATERIALWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgvertexcolormaterial.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGVertexColorMaterialWrapper : public QSGVertexColorMaterial
{
public:
    QSGVertexColorMaterialWrapper();
    QSGVertexColorMaterialWrapper(const QSGVertexColorMaterialWrapper &) = delete;
    QSGVertexColorMaterialWrapper& operator=(const QSGVertexColorMaterialWrapper &) = delete;
    QSGVertexColorMaterialWrapper(QSGVertexColorMaterialWrapper &&) = delete;
    QSGVertexColorMaterialWrapper& operator=(QSGVertexColorMaterialWrapper &&) = delete;
    ~QSGVertexColorMaterialWrapper() override;

    int compare(const ::QSGMaterial * other) const override;
    ::QSGMaterialShader * createShader(::QSGRendererInterface::RenderMode renderMode) const override;
    ::QSGMaterialType * type() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QSGVERTEXCOLORMATERIALWRAPPER_H
