// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_LOADERWRAPPER_H
#define SBK_LOADERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtScxml/qscxmlcompiler.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class LoaderWrapper : public QScxmlCompiler::Loader
{
public:
    LoaderWrapper();
    LoaderWrapper(const LoaderWrapper &) = delete;
    LoaderWrapper& operator=(const LoaderWrapper &) = delete;
    LoaderWrapper(LoaderWrapper &&) = delete;
    LoaderWrapper& operator=(LoaderWrapper &&) = delete;
    ~LoaderWrapper() override;

    ::QByteArray load(const ::QString & name, const ::QString & baseDir, ::QStringList * errors) override;
    static ::QByteArray sbk_o_load(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & name, const ::QString & baseDir, ::QStringList * errors);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_LOADERWRAPPER_H
