// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSCXMLTABLEDATAWRAPPER_H
#define SBK_QSCXMLTABLEDATAWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtScxml/qscxmltabledata.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QScxmlTableDataWrapper : public QScxmlTableData
{
public:
    QScxmlTableDataWrapper();
    QScxmlTableDataWrapper(const QScxmlTableDataWrapper &) = delete;
    QScxmlTableDataWrapper& operator=(const QScxmlTableDataWrapper &) = delete;
    QScxmlTableDataWrapper(QScxmlTableDataWrapper &&) = delete;
    QScxmlTableDataWrapper& operator=(QScxmlTableDataWrapper &&) = delete;
    ~QScxmlTableDataWrapper() override;

    ::QScxmlExecutableContent::AssignmentInfo assignmentInfo(int assignmentId) const override;
    static ::QScxmlExecutableContent::AssignmentInfo sbk_o_assignmentInfo(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int assignmentId);
    int * dataNames(int * count) const override;
    static int * sbk_o_dataNames(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int * count);
    ::QScxmlExecutableContent::EvaluatorInfo evaluatorInfo(int evaluatorId) const override;
    static ::QScxmlExecutableContent::EvaluatorInfo sbk_o_evaluatorInfo(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int evaluatorId);
    ::QScxmlExecutableContent::ForeachInfo foreachInfo(int foreachId) const override;
    static ::QScxmlExecutableContent::ForeachInfo sbk_o_foreachInfo(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int foreachId);
    int initialSetup() const override;
    static int sbk_o_initialSetup(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    int * instructions() const override;
    static int * sbk_o_instructions(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QString name() const override;
    static ::QString sbk_o_name(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QScxmlInvokableServiceFactory * serviceFactory(int id) const override;
    static ::QScxmlInvokableServiceFactory * sbk_o_serviceFactory(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int id);
    const qint32 * stateMachineTable() const override;
    static const qint32 * sbk_o_stateMachineTable(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QString string(int id) const override;
    static ::QString sbk_o_string(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int id);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QSCXMLTABLEDATAWRAPPER_H
