// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAMBIENTTEMPERATUREFILTERWRAPPER_H
#define SBK_QAMBIENTTEMPERATUREFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qambienttemperaturesensor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAmbientTemperatureFilterWrapper : public QAmbientTemperatureFilter
{
public:
    QAmbientTemperatureFilterWrapper(const QAmbientTemperatureFilterWrapper &) = delete;
    QAmbientTemperatureFilterWrapper& operator=(const QAmbientTemperatureFilterWrapper &) = delete;
    QAmbientTemperatureFilterWrapper(QAmbientTemperatureFilterWrapper &&) = delete;
    QAmbientTemperatureFilterWrapper& operator=(QAmbientTemperatureFilterWrapper &&) = delete;
    ~QAmbientTemperatureFilterWrapper() override;

    bool filter(::QAmbientTemperatureReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QAmbientTemperatureReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QAMBIENTTEMPERATUREFILTERWRAPPER_H
