// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QLIDFILTERWRAPPER_H
#define SBK_QLIDFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qlidsensor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QLidFilterWrapper : public QLidFilter
{
public:
    QLidFilterWrapper(const QLidFilterWrapper &) = delete;
    QLidFilterWrapper& operator=(const QLidFilterWrapper &) = delete;
    QLidFilterWrapper(QLidFilterWrapper &&) = delete;
    QLidFilterWrapper& operator=(QLidFilterWrapper &&) = delete;
    ~QLidFilterWrapper() override;

    bool filter(::QLidReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QLidReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QLIDFILTERWRAPPER_H
