// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QORIENTATIONFILTERWRAPPER_H
#define SBK_QORIENTATIONFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qorientationsensor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QOrientationFilterWrapper : public QOrientationFilter
{
public:
    QOrientationFilterWrapper(const QOrientationFilterWrapper &) = delete;
    QOrientationFilterWrapper& operator=(const QOrientationFilterWrapper &) = delete;
    QOrientationFilterWrapper(QOrientationFilterWrapper &&) = delete;
    QOrientationFilterWrapper& operator=(QOrientationFilterWrapper &&) = delete;
    ~QOrientationFilterWrapper() override;

    bool filter(::QOrientationReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QOrientationReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QORIENTATIONFILTERWRAPPER_H
