// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPRESSUREFILTERWRAPPER_H
#define SBK_QPRESSUREFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qpressuresensor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QPressureFilterWrapper : public QPressureFilter
{
public:
    QPressureFilterWrapper(const QPressureFilterWrapper &) = delete;
    QPressureFilterWrapper& operator=(const QPressureFilterWrapper &) = delete;
    QPressureFilterWrapper(QPressureFilterWrapper &&) = delete;
    QPressureFilterWrapper& operator=(QPressureFilterWrapper &&) = delete;
    ~QPressureFilterWrapper() override;

    bool filter(::QPressureReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QPressureReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QPRESSUREFILTERWRAPPER_H
