// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSENSORBACKENDFACTORYWRAPPER_H
#define SBK_QSENSORBACKENDFACTORYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qsensormanager.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSensorBackendFactoryWrapper : public QSensorBackendFactory
{
public:
    QSensorBackendFactoryWrapper();
    QSensorBackendFactoryWrapper(const QSensorBackendFactoryWrapper &) = delete;
    QSensorBackendFactoryWrapper& operator=(const QSensorBackendFactoryWrapper &) = delete;
    QSensorBackendFactoryWrapper(QSensorBackendFactoryWrapper &&) = delete;
    QSensorBackendFactoryWrapper& operator=(QSensorBackendFactoryWrapper &&) = delete;
    ~QSensorBackendFactoryWrapper() override;

    ::QSensorBackend * createBackend(::QSensor * sensor) override;
    static ::QSensorBackend * sbk_o_createBackend(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSensor * sensor);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QSENSORBACKENDFACTORYWRAPPER_H
