// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSENSORCHANGESINTERFACEWRAPPER_H
#define SBK_QSENSORCHANGESINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qsensorplugin.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSensorChangesInterfaceWrapper : public QSensorChangesInterface
{
public:
    QSensorChangesInterfaceWrapper();
    QSensorChangesInterfaceWrapper(const QSensorChangesInterfaceWrapper &) = delete;
    QSensorChangesInterfaceWrapper& operator=(const QSensorChangesInterfaceWrapper &) = delete;
    QSensorChangesInterfaceWrapper(QSensorChangesInterfaceWrapper &&) = delete;
    QSensorChangesInterfaceWrapper& operator=(QSensorChangesInterfaceWrapper &&) = delete;
    ~QSensorChangesInterfaceWrapper() override;

    void sensorsChanged() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QSENSORCHANGESINTERFACEWRAPPER_H
