// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSENSORFILTERWRAPPER_H
#define SBK_QSENSORFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qsensor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSensorFilterWrapper : public QSensorFilter
{
public:
    QSensorFilterWrapper();
    QSensorFilterWrapper(const QSensorFilterWrapper &) = delete;
    QSensorFilterWrapper& operator=(const QSensorFilterWrapper &) = delete;
    QSensorFilterWrapper(QSensorFilterWrapper &&) = delete;
    QSensorFilterWrapper& operator=(QSensorFilterWrapper &&) = delete;
    ~QSensorFilterWrapper() override;

    bool filter(::QSensorReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSensorReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void sbk_o_setSensor(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QSensor * sensor);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSENSORFILTERWRAPPER_H
