// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSENSORPLUGININTERFACEWRAPPER_H
#define SBK_QSENSORPLUGININTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qsensorplugin.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSensorPluginInterfaceWrapper : public QSensorPluginInterface
{
public:
    QSensorPluginInterfaceWrapper();
    QSensorPluginInterfaceWrapper(const QSensorPluginInterfaceWrapper &) = delete;
    QSensorPluginInterfaceWrapper& operator=(const QSensorPluginInterfaceWrapper &) = delete;
    QSensorPluginInterfaceWrapper(QSensorPluginInterfaceWrapper &&) = delete;
    QSensorPluginInterfaceWrapper& operator=(QSensorPluginInterfaceWrapper &&) = delete;
    ~QSensorPluginInterfaceWrapper() override;

    void registerSensors() override;
    static void sbk_o_registerSensors(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QSENSORPLUGININTERFACEWRAPPER_H
