// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCANBUSFACTORYWRAPPER_H
#define SBK_QCANBUSFACTORYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qcanbusfactory.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QCanBusFactoryWrapper : public QCanBusFactory
{
public:
    QCanBusFactoryWrapper();
    QCanBusFactoryWrapper(const QCanBusFactoryWrapper &) = delete;
    QCanBusFactoryWrapper& operator=(const QCanBusFactoryWrapper &) = delete;
    QCanBusFactoryWrapper(QCanBusFactoryWrapper &&) = delete;
    QCanBusFactoryWrapper& operator=(QCanBusFactoryWrapper &&) = delete;
    ~QCanBusFactoryWrapper() override;

    ::QList<QCanBusDeviceInfo> availableDevices(::QString * errorMessage) const override;
    static ::QList<QCanBusDeviceInfo> sbk_o_availableDevices(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QString * errorMessage);
    ::QCanBusDevice * createDevice(const ::QString & interfaceName, ::QString * errorMessage) const override;
    static ::QCanBusDevice * sbk_o_createDevice(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & interfaceName, ::QString * errorMessage);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QCANBUSFACTORYWRAPPER_H
