// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMODBUSRESPONSEWRAPPER_H
#define SBK_QMODBUSRESPONSEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbuspdu.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QModbusResponseWrapper : public QModbusResponse
{
public:
    QModbusResponseWrapper();
    QModbusResponseWrapper(::QModbusPdu::FunctionCode code, const ::QByteArray & newData = QByteArray());
    QModbusResponseWrapper(const ::QModbusPdu & pdu);
    QModbusResponseWrapper(const QModbusResponseWrapper &) = delete;
    QModbusResponseWrapper& operator=(const QModbusResponseWrapper &) = delete;
    QModbusResponseWrapper(QModbusResponseWrapper &&) = delete;
    QModbusResponseWrapper& operator=(QModbusResponseWrapper &&) = delete;
    ~QModbusResponseWrapper() override;

    void setFunctionCode(::QModbusPdu::FunctionCode code) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QMODBUSRESPONSEWRAPPER_H
