// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWEBSOCKETWRAPPER_H
#define SBK_QWEBSOCKETWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWebSockets/qwebsocket.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QWebSocketWrapper : public QWebSocket
{
public:
    QWebSocketWrapper(const ::QString & origin = QString(), ::QWebSocketProtocol::Version version = QWebSocketProtocol::VersionLatest, ::QObject * parent = nullptr);
    QWebSocketWrapper(const QWebSocketWrapper &) = delete;
    QWebSocketWrapper& operator=(const QWebSocketWrapper &) = delete;
    QWebSocketWrapper(QWebSocketWrapper &&) = delete;
    QWebSocketWrapper& operator=(QWebSocketWrapper &&) = delete;
    ~QWebSocketWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QWEBSOCKETWRAPPER_H
