// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGRAPHICSANCHORLAYOUTWRAPPER_H
#define SBK_QGRAPHICSANCHORLAYOUTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicsanchorlayout.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGraphicsAnchorLayoutWrapper : public QGraphicsAnchorLayout
{
public:
    QGraphicsAnchorLayoutWrapper(::QGraphicsLayoutItem * parent = nullptr);
    QGraphicsAnchorLayoutWrapper(const QGraphicsAnchorLayoutWrapper &) = delete;
    QGraphicsAnchorLayoutWrapper& operator=(const QGraphicsAnchorLayoutWrapper &) = delete;
    QGraphicsAnchorLayoutWrapper(QGraphicsAnchorLayoutWrapper &&) = delete;
    QGraphicsAnchorLayoutWrapper& operator=(QGraphicsAnchorLayoutWrapper &&) = delete;
    ~QGraphicsAnchorLayoutWrapper() override;

    int count() const override;
    void getContentsMargins(qreal * left, qreal * top, qreal * right, qreal * bottom) const override;
    void invalidate() override;
    bool isEmpty() const override;
    ::QGraphicsLayoutItem * itemAt(int index) const override;
    void removeAt(int index) override;
    void setGeometry(const ::QRectF & rect) override;
    ::QSizeF sizeHint(::Qt::SizeHint which, const ::QSizeF & constraint = QSizeF()) const override;
    void updateGeometry() override;
    void widgetEvent(::QEvent * e) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QGRAPHICSANCHORLAYOUTWRAPPER_H
