// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGRAPHICSSCENEEVENTWRAPPER_H
#define SBK_QGRAPHICSSCENEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGraphicsSceneEventWrapper : public QGraphicsSceneEvent
{
public:
    QGraphicsSceneEventWrapper(::QEvent::Type type);
    QGraphicsSceneEventWrapper(const QGraphicsSceneEventWrapper &) = delete;
    QGraphicsSceneEventWrapper& operator=(const QGraphicsSceneEventWrapper &) = delete;
    QGraphicsSceneEventWrapper(QGraphicsSceneEventWrapper &&) = delete;
    QGraphicsSceneEventWrapper& operator=(QGraphicsSceneEventWrapper &&) = delete;
    ~QGraphicsSceneEventWrapper() override;

    ::QEvent * clone() const override;
    static ::QEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGRAPHICSSCENEEVENTWRAPPER_H
