// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGRAPHICSSCENEWHEELEVENTWRAPPER_H
#define SBK_QGRAPHICSSCENEWHEELEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGraphicsSceneWheelEventWrapper : public QGraphicsSceneWheelEvent
{
public:
    QGraphicsSceneWheelEventWrapper(::QEvent::Type type = QEvent::Type::None);
    QGraphicsSceneWheelEventWrapper(const QGraphicsSceneWheelEventWrapper &) = delete;
    QGraphicsSceneWheelEventWrapper& operator=(const QGraphicsSceneWheelEventWrapper &) = delete;
    QGraphicsSceneWheelEventWrapper(QGraphicsSceneWheelEventWrapper &&) = delete;
    QGraphicsSceneWheelEventWrapper& operator=(QGraphicsSceneWheelEventWrapper &&) = delete;
    ~QGraphicsSceneWheelEventWrapper() override;

    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGRAPHICSSCENEWHEELEVENTWRAPPER_H
