// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QITEMEDITORCREATORBASEWRAPPER_H
#define SBK_QITEMEDITORCREATORBASEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qitemeditorfactory.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QItemEditorCreatorBaseWrapper : public QItemEditorCreatorBase
{
public:
    QItemEditorCreatorBaseWrapper();
    QItemEditorCreatorBaseWrapper(const QItemEditorCreatorBaseWrapper &) = delete;
    QItemEditorCreatorBaseWrapper& operator=(const QItemEditorCreatorBaseWrapper &) = delete;
    QItemEditorCreatorBaseWrapper(QItemEditorCreatorBaseWrapper &&) = delete;
    QItemEditorCreatorBaseWrapper& operator=(QItemEditorCreatorBaseWrapper &&) = delete;
    ~QItemEditorCreatorBaseWrapper() override;

    ::QWidget * createWidget(::QWidget * parent) const override;
    static ::QWidget * sbk_o_createWidget(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QWidget * parent);
    ::QByteArray valuePropertyName() const override;
    static ::QByteArray sbk_o_valuePropertyName(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QITEMEDITORCREATORBASEWRAPPER_H
