// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSCROLLERPROPERTIESWRAPPER_H
#define SBK_QSCROLLERPROPERTIESWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qscrollerproperties.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QScrollerPropertiesWrapper : public QScrollerProperties
{
public:
    QScrollerPropertiesWrapper();
    QScrollerPropertiesWrapper(const QScrollerPropertiesWrapper &) = delete;
    QScrollerPropertiesWrapper(const QScrollerProperties& self) : QScrollerProperties(self)
    {
    }
    QScrollerPropertiesWrapper& operator=(const QScrollerPropertiesWrapper &) = delete;
    QScrollerPropertiesWrapper(QScrollerPropertiesWrapper &&) = delete;
    QScrollerPropertiesWrapper& operator=(QScrollerPropertiesWrapper &&) = delete;
    ~QScrollerPropertiesWrapper() override;

    static void pysideInitQtMetaTypes();

private:
};

#endif // SBK_QSCROLLERPROPERTIESWRAPPER_H
